Module javafx.base
Package javafx.beans.property

# Class BooleanPropertyBase

java.lang.Object
javafx.beans.binding.BooleanExpression
javafx.beans.property.ReadOnlyBooleanProperty
javafx.beans.property.BooleanProperty
javafx.beans.property.BooleanPropertyBase

All Implemented Interfaces:
  `Observable`, `Property<Boolean>`, `ReadOnlyProperty<Boolean>`, `ObservableBooleanValue`, `ObservableValue<Boolean>`, `WritableBooleanValue`, `WritableValue<Boolean>`

Direct Known Subclasses:
  `SimpleBooleanProperty`, `StyleableBooleanProperty`

public abstract class BooleanPropertyBase extends BooleanProperty
The class `BooleanPropertyBase` is the base class for a property wrapping a `boolean` value. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.

Since:
  JavaFX 2.0
See Also:
  - `BooleanProperty`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BooleanPropertyBase()`
  The constructor of the `BooleanPropertyBase`.
  `BooleanPropertyBase(boolean initialValue)`
  The constructor of the `BooleanPropertyBase`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `addListener(ChangeListener<? super Boolean> listener)`
  Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
  `void`
  `bind(ObservableValue<? extends Boolean> rawObservable)`
  Create a unidirection binding for this `Property`.
  `protected void`
  `fireValueChangedEvent()`
  Sends notifications to all attached `InvalidationListeners` and `ChangeListeners`.
  `boolean`
  `get()`
  Get the wrapped value.
  `protected void`
  `invalidated()`
  The method `invalidated()` can be overridden to receive invalidation notifications.
  `boolean`
  `isBound()`
  Can be used to check, if a `Property` is bound.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `void`
  `removeListener(ChangeListener<? super Boolean> listener)`
  Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
  `void`
  `set(boolean newValue)`
  Set the wrapped value.
  `String`
  `toString()`
  Returns a string representation of this `BooleanPropertyBase` object.
  `void`
  `unbind()`
  Remove the unidirectional binding for this `Property`.

  ### Methods declared in class javafx.beans.property.BooleanProperty

  `asObject, bindBidirectional, booleanProperty, setValue, unbindBidirectional`

  ### Methods declared in class javafx.beans.property.ReadOnlyBooleanProperty

  `readOnlyBooleanProperty`

  ### Methods declared in class javafx.beans.binding.BooleanExpression

  `and, asString, booleanExpression, booleanExpression, getValue, isEqualTo, isNotEqualTo, not, or`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `getValue`

  ### Methods declared in interface javafx.beans.property.ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface javafx.beans.value.WritableValue

  `getValue`

- ## Constructor Details

  - ### BooleanPropertyBase

    public BooleanPropertyBase()
    The constructor of the `BooleanPropertyBase`.

  - ### BooleanPropertyBase

    public BooleanPropertyBase(boolean initialValue)
    The constructor of the `BooleanPropertyBase`.
    Parameters:
      `initialValue` - the initial value of the wrapped value

- ## Method Details

  - ### addListener

    public void addListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `Observable.removeListener(InvalidationListener)`

  - ### removeListener

    public void removeListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `Observable.addListener(InvalidationListener)`

  - ### addListener

    public void addListener(ChangeListener<? super Boolean> listener)
    Description copied from interface: `ObservableValue`
    Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

    The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `ObservableValue.removeListener(ChangeListener)`

  - ### removeListener

    public void removeListener(ChangeListener<? super Boolean> listener)
    Description copied from interface: `ObservableValue`
    Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `ObservableValue.addListener(ChangeListener)`

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent()
    Sends notifications to all attached `InvalidationListeners` and `ChangeListeners`. This method is called when the value is changed, either manually by calling `set(boolean)` or in case of a bound property, if the binding becomes invalid.

  - ### invalidated

    protected void invalidated()
    The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

  - ### get

    public boolean get()
    Get the wrapped value. Unlike `WritableValue.getValue()`, this method returns primitive boolean. Needs to be identical to `WritableValue.getValue()`.
    Returns:
      The current value

  - ### set

    public void set(boolean newValue)
    Set the wrapped value. Unlike `WritableBooleanValue.setValue(java.lang.Boolean)`, this method uses primitive boolean.
    Parameters:
      `newValue` - The new value

  - ### isBound

    public boolean isBound()
    Can be used to check, if a `Property` is bound.
    Returns:
      `true` if the `Property` is bound, `false` otherwise
    See Also:
      - `Property.bind(javafx.beans.value.ObservableValue)`

  - ### bind

    public void bind(ObservableValue<? extends Boolean> rawObservable)
    Create a unidirection binding for this `Property`.

    Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated. Note:

    Parameters:
      `rawObservable` - The observable this `Property` should be bound to.

  - ### unbind

    public void unbind()
    Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.
    See Also:
      - `Property.bind(javafx.beans.value.ObservableValue)`

  - ### toString

    public String toString()
    Returns a string representation of this `BooleanPropertyBase` object.
    Overrides:
      `toString` in class `BooleanProperty`
    Returns:
      a string representation of this `BooleanPropertyBase` object.